/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
/**
* This item class contains the methods to set, get and validate the attribute present in Image BoxSynchronization Sequence.
 */


public class ImageBoxSynchronizationSequenceItem extends Item
{

	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	ImageBoxSynchronizationSequenceItem()
	{
		super();
	}


	/**
	 * This constructor creates the item and internal code sequence macro with specified TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	ImageBoxSynchronizationSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates ImageBoxSynchronizationSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	ImageBoxSynchronizationSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/**
	 * Validates all the attributes in ImageBoxSynchronizationSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try
		{
			if(!contains(0x0072,0x0432))
				throw new MandatoryMissingException("0072,0432") ;
			if(!contains(0x0072,0x0434))
				throw new MandatoryMissingException("0072,0434") ;
			
		}
		catch( MandatoryMissingException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),ce); 
		}
		return true;
	}
	
	public void setSynchronizedImageBoxList(short[] arrSynchronizedImageBoxList)
	{
		/* Accept the Referenced Frame Numbers in Array of short format of type US.
		 * Multi-valued list of two or more Image Box Number (0072,0302) values.
		 * Indicates that the display of multiple image frames within the specified Image Boxes are synchronized.
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x0072, 0x0432, arrSynchronizedImageBoxList,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0432,DicomConstants.DCM_DT_US, arrSynchronizedImageBoxList);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Multi-valued list of two or more Image Box Number.
	 * @return short Array - frames in a Multi-frame SOP Instance.
	 */
	public short[] getSynchronizedImageBoxList()
	{
		Object objValue = getValue(0x0072, 0x0432);
		if(objValue != null)
			return (short[])objValue;
		return null;
	}

	
	/**
	 * Sets the Type of synchronization between Image Boxes.
	 * @param strTypeofSynchronization Specifies type of the value encoded in this Item
	 */
	public void setTypeofSynchronization(String strTypeofSynchronization)
	{
		/* Accept the Value Type in String format of type CS.
		 * Type of synchronization between Image Boxes Defined Terms:FRAME,POSITION,TIME,PHASE	
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0072, 0x0434, strTypeofSynchronization,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0072, 0x0434,DicomConstants.DCM_DT_CS, strTypeofSynchronization);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves type of the Type of Synchronization Item
	 * @return String - Type of the value encoded in this Item
	 */
	public String getValueType()
	{
		Object objValue = getValue(0x0072, 0x0434);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

}
